WCNsGrab = {
    
    NsGrab : function() {
    }
}

WCNsGrab.NsGrab.prototype = {
    
    grabSelection : function(grabBox, cutMode) {
        var viewDim = new WCDimensions.BrowserViewportDimensions();
        var box = new WCDimensions.Box(viewDim.getScrollX() + grabBox.getX(), viewDim.getScrollY() + grabBox.getY(), grabBox.getWidth(), grabBox.getHeight());
        this.grab(WCNsUtils.getCurrentBrowserWindow(), box, cutMode);
    },
    
    grab : function(windowToGrab, box, cutMode) {
        var format = Webcut.format();
        var canvas = this.prepareCanvas(box.getWidth(), box.getHeight());
        var context = this.prepareContext(canvas, box);
        context.drawWindow(windowToGrab, box.getX(), box.getY(), box.getWidth(), box.getHeight(), "rgb(0,0,0)");
        context.restore();

        var dataUrl = canvas.toDataURL("image/" + format);
        if (cutMode == 1) {
            this.saveToMobaCut(dataUrl, "http://mobacut.t-ny.net/upload.php");
        } else if (cutMode == 2) {
            this.saveToFlickr(dataUrl, "http://mobacut.t-ny.net/flickr_upload.php?s="+Webcut.flickrPrivacy()+"&t="+encodeURI(Webcut.flickrTags()));
        } else if (cutMode == 3) {
            this.saveToTumblr(dataUrl);
        } else if (cutMode == 4) {
            this.saveToFile(dataUrl, format);
        } else if (cutMode == 5) {
            var comment = window.prompt("メールに含める文字を入力してください[省略可]", document.commandDispatcher.focusedWindow.document.title);
            if (comment != null) {
                this.sendmail(dataUrl, "http://mobacut.t-ny.net/upload.php?m="+encodeURI(Webcut.mailAddress())+"&f="+Webcut.mailFormat() + encodeURI((comment != null)?"&c="+comment:""));
            }
        } else {
            var comment = window.prompt("コメントを入力してください。[120文字程度]", document.commandDispatcher.focusedWindow.document.title);
            if (comment != null) {
                this.saveToTwitter(dataUrl, comment);
            }
        }
    },

    fileUpload : function(dataUrl, requestUrl, params) {
        var binaryInputStream = WCNsUtils.dataUrlToBinaryInputStream(dataUrl);
        var fileName = "capture.png";
        var BOUNDARY = "111222111";
        var nsIStringInputStream    = Components.interfaces.nsIStringInputStream;
        var focusedWindow = document.commandDispatcher.focusedWindow;

        var mis = Components.classes["@mozilla.org/io/multiplex-input-stream;1"].createInstance(Components.interfaces.nsIMultiplexInputStream);

        var hsis = Components.classes["@mozilla.org/io/string-input-stream;1"].createInstance(nsIStringInputStream);
        var sheader = new String();
        sheader += "\r\n";

        for (var i in params) {
            sheader += "--" + BOUNDARY + "\r\nContent-disposition: form-data;name=\""+i+"\"\r\n\r\n"+encodeURI(params[i])+"\r\n";
        }

        sheader += "--" + BOUNDARY + "\r\nContent-disposition: form-data;name=\"title\"\r\n\r\n"+encodeURI(focusedWindow.document.title)+"\r\n";
        sheader += "--" + BOUNDARY + "\r\nContent-disposition: form-data;name=\"url\"\r\n\r\n"+encodeURI(focusedWindow.location.href)+"\r\n";
        sheader += "--" + BOUNDARY + "\r\nContent-disposition: form-data;name=\"addfile\"\r\n\r\n1\r\n";
        sheader += "--" + BOUNDARY + "\r\n"
        sheader += "Content-disposition: form-data;name=\"filename\";filename=\"" + fileName + "\"\r\n";
        sheader += "Content-Type: application/octet-stream\r\n";
        sheader += "Content-Length: " + binaryInputStream.available()+"\r\n\r\n";
        hsis.setData(sheader, sheader.length);

        var endsis = Components.classes["@mozilla.org/io/string-input-stream;1"].createInstance(nsIStringInputStream);
        var bs = new String("\r\n--" + BOUNDARY + "--\r\n");
        endsis.setData(bs, bs.length);

        mis.appendStream(hsis);
        mis.appendStream(binaryInputStream);
        mis.appendStream(endsis);

        var xmlreq = new XMLHttpRequest();
        xmlreq.open("POST", requestUrl, false);
        xmlreq.setRequestHeader("Content-Length", mis.available() - 2 );
        xmlreq.setRequestHeader("Content-Type", "multipart/form-data; boundary=" + BOUNDARY);

        xmlreq.send(mis);

        return xmlreq;
    },

    send : function(requestUrl) {
        var xmlreq = new XMLHttpRequest();
        xmlreq.open("GET", requestUrl, false);
        xmlreq.send(null);
        return xmlreq;
    },

    saveToMobaCut : function(dataUrl, requestUrl) {
        var xmlreq = this.fileUpload(dataUrl, requestUrl, {});

        window.open(xmlreq.responseText, 'MobaCut','menubar=no,toolbar=no,location=no,status=no,resizable=yes,scrollbars=yes,top=100,left=100,width=600,height=600');
    },

    sendmail : function(dataUrl, requestUrl) {
        var xmlreq = this.fileUpload(dataUrl, requestUrl, {});

        alert(xmlreq.responseText);
    },
    
    saveToFlickr : function(dataUrl, requestUrl) {
        var xmlreq = this.fileUpload(dataUrl, requestUrl, {});

        window.open(xmlreq.responseText, 'MobaCut','menubar=no,toolbar=no,location=no,status=no,resizable=yes,scrollbars=yes,top=100,left=100,width=900,height=680');
    },
    
    saveToTumblr : function(dataUrl) {
        var requestUrl = "https://secure1400.sakura.ne.jp/mobacut.t-ny.net/generate_pack_key.php";
        var xmlreq = this.send(requestUrl);
        if (xmlreq.status != 200) {
            var tumblrUploadError = document.getElementById("webcut-strings").getString("TumblrUploadError");
            alert(tumblrUploadError);
            return;
        }

        var packKey = xmlreq.responseText;

        // encrypt
        var cipherTextBase64 = WebcutBase64.encode(WebcutDes.encrypt(WebcutBase64.encode(Webcut.tumblrEMail()+"\n"+Webcut.tumblrPassword()),
                                                                     packKey));
        requestUrl = "https://secure1400.sakura.ne.jp/mobacut.t-ny.net/tumblr_upload.php";
        xmlreq = this.fileUpload(dataUrl, requestUrl, {u: cipherTextBase64, privacy: Webcut.tumblrPrivacy(), tags: Webcut.tumblrTags()});
        if (xmlreq.status != 200) {
            var tumblrUploadError = document.getElementById("webcut-strings").getString("TumblrUploadError");
            alert(tumblrUploadError);
            return;
        }

        if (Webcut.tumblrPopup()) {
            window.open(xmlreq.responseText, 'MobaCut','menubar=no,toolbar=no,location=no,status=no,resizable=yes,scrollbars=yes,top=100,left=100,width=900,height=800');
        }
    },
    
    saveToTwitter : function(dataUrl, comment) {
        var requestUrl = "http://mobacut.t-ny.net/twitter_upload.php?i="+encodeURI((comment != null)?"&c="+comment:"");

        var xmlreq = this.fileUpload(dataUrl, requestUrl, {});

        window.open(xmlreq.responseText, 'MobaCut','menubar=no,toolbar=no,location=no,status=no,resizable=yes,scrollbars=yes,top=100,left=100,width=600,height=600');
    },
    
    saveToFile : function(dataUrl, format) {
        var nsFile = WCNsUtils.askUserForFile(Webcut.defaultFileName() + "." + format);
        if (nsFile != null) {
            var binaryInputStream = WCNsUtils.dataUrlToBinaryInputStream(dataUrl);
            var fileOutputStream = WCNsUtils.newFileOutputStream(nsFile);
            WCNsUtils.writeBinaryInputStreamToFileOutputStream(binaryInputStream, fileOutputStream);
            fileOutputStream.close();
        }
    },

    prepareContext : function(canvas, box) {
        var context = canvas.getContext("2d");
        context.clearRect(box.getX(), box.getY(), box.getWidth(), box.getHeight());
        context.save();
        return context;
    },
    
    prepareCanvas : function(width, height) {
        var styleWidth = width + "px";
        var styleHeight = height + "px";
        
        var grabCanvas = document.getElementById("webcut_buffer_canvas");
        grabCanvas.width = width;
        grabCanvas.style.width = styleWidth;
        grabCanvas.style.maxWidth = styleWidth;
        grabCanvas.height = height;
        grabCanvas.style.height = styleHeight;
        grabCanvas.style.maxHeight = styleHeight;
    
        return grabCanvas;
    }
}