Webcut = {
    nsGrab : new WCNsGrab.NsGrab(),
    
    grabber : function() {
        return this.nsGrab;
    },
    
    mailAddress : function() {
        var mail = nsPreferences.copyUnicharPref(WCPrefs.mailAddress);
        if (mail == null) {
            mail = "";
        }
        return mail;
    },
    
    mailFormat : function() {
        return nsPreferences.getIntPref(WCPrefs.mailFormat);
    },
    
    flickrPrivacy : function() {
        return nsPreferences.getIntPref(WCPrefs.flickrPrivacy);
    },
    
    flickrTags : function() {
        var tags = nsPreferences.copyUnicharPref(WCPrefs.flickrTags);
        if (tags == null) {
            tags = "";
        }
        return tags;
    },
    
    tumblrEMail : function() {
        var email = nsPreferences.copyUnicharPref(WCPrefs.tumblrEMail);
        if (email == null) {
            email = "";
        }
        return email;
    },
    
    tumblrPassword : function() {
        var password = nsPreferences.copyUnicharPref(WCPrefs.tumblrPassword);
        if (password == null) {
            password = "";
        }
        return password;
    },

    tumblrPrivacy : function() {
        return nsPreferences.getIntPref(WCPrefs.tumblrPrivacy);
    },
    
    tumblrTags : function() {
        var tags = nsPreferences.copyUnicharPref(WCPrefs.tumblrTags);
        if (tags == null) {
            tags = "";
        }
        return tags;
    },
    
    tumblrPopup : function() {
        return nsPreferences.getBoolPref(WCPrefs.tumblrPopup);
    },

    twitterId : function() {
        var id = nsPreferences.copyUnicharPref(WCPrefs.twitterId);
        if (id == null) {
            id = "";
        }
        return id;
    },
    
    twitterPassword : function() {
        var password = nsPreferences.copyUnicharPref(WCPrefs.twitterPassword);
        if (password == null) {
            password = "";
        }
        return password;
    },

    format : function() {
        if (nsPreferences.getIntPref(WCPrefs.imageFormat) == 0) {
            return "png";
        } else {
            return "jpeg";
        }
    },

    defaultFileName : function() {
        filename = window.content.document.title;
        if (nsPreferences.getBoolPref(WCPrefs.includeTimeStampInFilename)) {
            dt = new Date();
            filename = filename + "_" + dt.getTime();    
        }
        return filename;
    },
    grabDocumentPortion : function(offsetX, offsetY, width, height, cutMode) {
        this.grabber().grabSelection(new WCDimensions.Box(offsetX, offsetY, width, height), cutMode)
    }
}
